/*
 * Copyright 2019 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v6.0
processor: MKL27Z64xxx4
package_id: MKL27Z64VLH4
mcu_data: ksdk2_0
processor_version: 6.0.1
board: FRDM-KL27Z
functionalGroups:
- name: BOARD_InitPeripherals
  id_prefix: DEMO_
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system_54b53072540eeeb8f8e9343e71f28176'
- global_system_definitions: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'msg'
- type_id: 'msg_6e2baaf3b97dbeef01c0043275f9a0e7'
- global_messages: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_InitPeripherals functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * DMA initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'DMA'
- type: 'dma'
- mode: 'basic'
- type_id: 'dma_cb8220597343022981727d8655725baf'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'DMA'
- config_sets:
  - fsl_dma:
    - dma_table:
      - 0: []
    - dma_channels:
      - 0:
        - dma_channel:
          - channel_prefix_id: 'ADC0'
          - DMAn: '0'
          - DMA_source: 'kDmaRequestMux0ADC0'
          - enable_custom_name: 'false'
        - init_callback: 'false'
        - callback_function: ''
        - callback_user_data: ''
        - init_channel_link: 'false'
        - channel_link:
          - linkType: 'kDMA_ChannelLinkDisable'
          - channel1: '0'
          - channel2: '0'
        - cycle_steal: 'true'
        - async_mode: 'true'
        - auto_align_mode: 'false'
        - init_interrupt: 'true'
        - enable_interrupt: 'true'
        - interrupt_channel:
          - IRQn: 'DMA0_IRQn'
          - enable_priority: 'false'
          - priority: '0'
          - enable_custom_name: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/* Channel ADC0 global variables */
dma_handle_t DEMO_DMA_ADC0_Handle;

void DEMO_DMA_init(void)
{
    /* Channel ADC0 initialization */
    /* Set the source kDmaRequestMux0ADC0 request in the DMAMUX */
    DMAMUX_SetSource(DEMO_DMA_DMAMUX_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, DEMO_DMA_ADC0_DMA_REQUEST);
    /* Enable the 0 channel in the DMAMUX */
    DMAMUX_EnableChannel(DEMO_DMA_DMAMUX_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
    /* Create the DMA DEMO_DMA_ADC0_Handle handle */
    DMA_CreateHandle(&DEMO_DMA_ADC0_Handle, DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
    DMA_EnableCycleSteal(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, true);
    DMA_EnableAutoAlign(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, false);
    DMA_EnableAsyncRequest(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, true);
    DMA_EnableInterrupts(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
    /* Enable interrupt DMA0_IRQn request in the NVIC */
    EnableIRQ(DEMO_DMA_DMA_CH_INT_DONE_0_IRQN);
}

/***********************************************************************************************************************
 * ADC16 initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'ADC16'
- type: 'adc16'
- mode: 'ADC'
- type_id: 'adc16_7d827be2dc433dc756d94a7ce88cbcc5'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'ADC0'
- config_sets:
  - fsl_adc16:
    - adc16_config:
      - referenceVoltageSource: 'kADC16_ReferenceVoltageSourceVref'
      - clockSource: 'kADC16_ClockSourceAsynchronousClock'
      - enableAsynchronousClock: 'true'
      - clockDivider: 'kADC16_ClockDivider8'
      - resolution: 'kADC16_Resolution16Bit'
      - longSampleMode: 'kADC16_LongSampleCycle24'
      - enableHighSpeed: 'false'
      - enableLowPower: 'true'
      - enableContinuousConversion: 'false'
    - adc16_channel_mux_mode: 'kADC16_ChannelMuxA'
    - adc16_hardware_compare_config:
      - hardwareCompareModeEnable: 'false'
    - doAutoCalibration: 'true'
    - trigger: 'true'
    - hardwareAverageConfiguration: 'kADC16_HardwareAverageDisabled'
    - enable_dma: 'true'
    - enable_irq: 'false'
    - adc_interrupt:
      - IRQn: 'ADC0_IRQn'
      - enable_priority: 'false'
      - priority: '0'
      - enable_custom_name: 'false'
    - adc16_channels_config:
      - 0:
        - enableDifferentialConversion: 'false'
        - channelNumber: 'SE.26'
        - enableInterruptOnConversionCompleted: 'false'
        - channelGroup: '0'
        - initializeChannel: 'true'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
adc16_channel_config_t DEMO_ADC16_channelsConfig[1] = {{
    .channelNumber                        = 26U,
    .enableDifferentialConversion         = false,
    .enableInterruptOnConversionCompleted = false,
}};
const adc16_config_t DEMO_ADC16_config              = {.referenceVoltageSource     = kADC16_ReferenceVoltageSourceVref,
                                          .clockSource                = kADC16_ClockSourceAsynchronousClock,
                                          .enableAsynchronousClock    = true,
                                          .clockDivider               = kADC16_ClockDivider8,
                                          .resolution                 = kADC16_Resolution16Bit,
                                          .longSampleMode             = kADC16_LongSampleCycle24,
                                          .enableHighSpeed            = false,
                                          .enableLowPower             = true,
                                          .enableContinuousConversion = false};
const adc16_channel_mux_mode_t DEMO_ADC16_muxMode   = kADC16_ChannelMuxA;
const adc16_hardware_average_mode_t DEMO_ADC16_hardwareAverageMode = kADC16_HardwareAverageDisabled;

void DEMO_ADC16_init(void)
{
    /* Initialize ADC16 converter */
    ADC16_Init(DEMO_ADC16_PERIPHERAL, &DEMO_ADC16_config);
    /* Make sure, that hardware trigger is used */
    ADC16_EnableHardwareTrigger(DEMO_ADC16_PERIPHERAL, true);
    /* Configure hardware average mode */
    ADC16_SetHardwareAverage(DEMO_ADC16_PERIPHERAL, DEMO_ADC16_hardwareAverageMode);
    /* Configure channel multiplexing mode */
    ADC16_SetChannelMuxMode(DEMO_ADC16_PERIPHERAL, DEMO_ADC16_muxMode);
    /* Perform auto calibration */
    ADC16_DoAutoCalibration(DEMO_ADC16_PERIPHERAL);
    /* Enable DMA requests from ADC0 peripheral */
    ADC16_EnableDMA(DEMO_ADC16_PERIPHERAL, true);
    /* Initialize channel */
    ADC16_SetChannelConfig(DEMO_ADC16_PERIPHERAL, 0U, &DEMO_ADC16_channelsConfig[0]);
}

/***********************************************************************************************************************
 * LPTMR initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'LPTMR'
- type: 'lptmr'
- mode: 'LPTMR_GENERAL'
- type_id: 'lptmr_2eeab91a1a42f8238f9ac768f18c65ae'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'LPTMR0'
- config_sets:
  - fsl_lptmr:
    - enableInterrupt: 'false'
    - interrupt:
      - IRQn: 'LPTMR0_IRQn'
      - enable_priority: 'false'
      - priority: '0'
      - enable_custom_name: 'false'
    - lptmr_config:
      - timerMode: 'kLPTMR_TimerModeTimeCounter'
      - pinSelect: 'ALT.0'
      - pinPolarity: 'kLPTMR_PinPolarityActiveHigh'
      - enableFreeRunning: 'false'
      - bypassPrescaler: 'true'
      - prescalerClockSource: 'kLPTMR_PrescalerClock_1'
      - clockSource: 'BOARD_BootClockRUN'
      - value: 'kLPTMR_Prescale_Glitch_0'
      - timerPeriod: '100000'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const lptmr_config_t DEMO_LPTMR_config = {.timerMode            = kLPTMR_TimerModeTimeCounter,
                                          .pinSelect            = kLPTMR_PinSelectInput_0,
                                          .pinPolarity          = kLPTMR_PinPolarityActiveHigh,
                                          .enableFreeRunning    = false,
                                          .bypassPrescaler      = true,
                                          .prescalerClockSource = kLPTMR_PrescalerClock_1,
                                          .value                = kLPTMR_Prescale_Glitch_0};

void DEMO_LPTMR_init(void)
{
    /* Initialize the LPTMR */
    LPTMR_Init(DEMO_LPTMR_PERIPHERAL, &DEMO_LPTMR_config);
    /* Set LPTMR period to 100000us */
    LPTMR_SetTimerPeriod(DEMO_LPTMR_PERIPHERAL, DEMO_LPTMR_TICKS);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void)
{
    /* Global initialization */
    DMAMUX_Init(DEMO_DMA_DMAMUX_BASEADDR);
    DMA_Init(DEMO_DMA_DMA_BASEADDR);

    /* Initialize components */
    DEMO_DMA_init();
    DEMO_ADC16_init();
    DEMO_LPTMR_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
}
